/*
 * $Id$
 *
 * Copyright and User License
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Copyright 2006-2019 CERN and INFN
 * 
 *
 * Please consult the LICENSE file for the license 
 *
 * DISCLAIMER
 * ~~~~~~~~~~
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT
 * NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY, OF
 * SATISFACTORY QUALITY, AND FITNESS FOR A PARTICULAR PURPOSE
 * OR USE ARE DISCLAIMED. THE COPYRIGHT HOLDERS AND THE
 * AUTHORS MAKE NO REPRESENTATION THAT THE SOFTWARE AND
 * MODIFICATIONS THEREOF, WILL NOT INFRINGE ANY PATENT,
 * COPYRIGHT, TRADE SECRET OR OTHER PROPRIETARY RIGHT.
 *
 * LIMITATION OF LIABILITY
 * ~~~~~~~~~~~~~~~~~~~~~~~
 * THE COPYRIGHT HOLDERS AND THE AUTHORS SHALL HAVE NO
 * LIABILITY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL,
 * CONSEQUENTIAL, EXEMPLARY, OR PUNITIVE DAMAGES OF ANY
 * CHARACTER INCLUDING, WITHOUT LIMITATION, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES, LOSS OF USE, DATA OR PROFITS,
 * OR BUSINESS INTERRUPTION, HOWEVER CAUSED AND ON ANY THEORY
 * OF CONTRACT, WARRANTY, TORT (INCLUDING NEGLIGENCE), PRODUCT
 * LIABILITY OR OTHERWISE, ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGES.
 *
 * Author:	Vasilis.Vlachoudis@cern.ch
 * Date:	04-Feb-2010
 */

#ifndef __GEO_H
#define __GEO_H

// Geometry constraints
#define MAXLIGHT	20
#define ROTDELTA	5
#define LEVEL_SHIFT	5	// FIXME change name
#define MAXLEVEL	5	// FIXME change name
#define MAXUSRBIN	10
#define MAXPALETTE	5

// Store the type of color in the alpha channel
#define FLAG_COLORMASK	 0x00FFFFFF	// color dword = II RR GG BB
#define FLAG_INFOMASK	 0xFF000000

#define FLAG_REGION	 0x01000000	// 01 filled with region color
#define FLAG_3D		 0x02000000	// 3D processing
#define FLAG_LATTICE	 0x04000000
#define FLAG_VOXEL	 0x08000000
#define FLAG_LABEL	 0x10000000
#define FLAG_ERROR	 0x20000000
#define FLAG_TRANSPARENT 0x80000000
#define FLAG_ANY	 0xFF000000

// Basic colors
#define COLOR_X		 0xFF0000
#define COLOR_Y		 0x00FF00
#define COLOR_Z		 0x0000FF

#define COLOR_X_DARK	 0x7F0000
#define COLOR_Y_DARK	 0x007F00
#define COLOR_Z_DARK	 0x00007F

#define COLOR_U		 0xFF00FF
#define COLOR_V		 0xFFFF00
#define COLOR_W		 0x00FFFF

#define COLOR_U_DARK	 0x7F007F
#define COLOR_V_DARK	 0x7F7F00
#define COLOR_W_DARK	 0x007F7F

// Global type definitions
typedef char char8[8];
typedef char char16[16];
typedef char char32[32];

#define DEFAULT_FONT	"fixed8x13.tga"

#endif
